.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
'\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
..
.TH ft_thread_get_value 1
.SH NAME
ft_thread_get_value \- get the nth value associated to a generated event
.SS SYNOPSIS

.Sp
.nf
\fB#include\fR <fthread.h>

int \fBft_thread_get_value\fR (ft_event_t evt,int n,void **result);

.Sp
.fi
.SS DESCRIPTION


\fBft_thread_get_value\fR returns the \fBn\fRth value
associated during the current instant to the event \fBevt\fR
through calls of \fBft_event_generate_value\fR or \fBft_scheduler_broadcast_value\fR.  If such a value exists, \fBft_thread_get_value\fR sets \fBresult\fR with a reference to it
and terminates immediately (that is, during the current instant).
Otherwise, it terminates at the next instant (returning \fBNEXT\fR) and \fBresult\fR is
then set to \fBNULL\fR.  

.SS RETURN VALUES


On success, the value 0 is returned (during the current instant).
Otherwise, a non-zero error code is returned. 

.SS ERRORS


.RS 3
.TP
\&\fBBADCREATE\fR 
The event \fBevt\fR is not correctly created.
.RE


.RS 3
.TP
\&\fBBADLINK\fR 
Either the calling thread is unlinked, or the scheduler of the calling thread and the one of 
\fBevt\fR are different.
.RE


.RS 3
.TP
\&\fBNEXT\fR 

Less than \fBn\fR values where actually associated to generations of \fBevt\fR
during the previous instant. 

.RE


.SS SEE ALSO

\fBft_thread_generate_value\fR (3), 
\fBft_scheduler_broadcast_value\fR (3).

.SH AUTHOR


